## ChangeLog

### 2023-09-06 - v0.5.0

- new feature : added PHP language code generation (factory classes)
- improvements :
	- removed jszip dependency using Haxe standard library (-75 kb)
	- compressed / minimized web application files (-80 kb)
- many fixes :
	- removed unneeded bottom and right margin from SVG files
	- fixed week / composite entity
	- SQL: fixed foreign keys generation
	- UML:
		- increased horizontal spacing between classes (to avoid navigation links overlaping)
		- show visibility for navigation links
	- Java: fixed Date / Time / DateTime & Float data types
	- Python:
		- fixed factory classes import ('from module import class' -> 'import module')
		- added class members
		- now handles List[Class]
		- fixed Float data type
	- web interface:
		- fixed swipe
		- fixed SVG copy
		- fixed source download
		- removed accessibility errors (https://wave.webaim.org/)
- (changed www/site generator)

### 2021-06-29 - v0.4.2

- fixed wrong diagram row count
- added grey background for domain diagram class titles
- added support for TX (XT)
- added support for comments
- web interface:
	- replaced material-icons by microns ones (-100 kb)
	- removed filesaver dependency


### 2021-06-23 - v0.4.1

- improved support for automatic french plural names
- fixed too small SVG canvas size
- display relation names with a bold font
- web interface improvements:
	- fixed UTF-8 display when using fullscreen
	- displays views names even if there is nothing else to show
	- improved copy functionality in web interface (now support SVG too)


### 2021-03-16 - v0.4.0

- added code generation (Haxe, Java, Python) (with support of genericity)
- added support for visibility specification in links
- added examples


### 2021-03-10 - v0.3.1

- fixed subclasses identification, thanks to Emmanuel Desmontils
- prevented superset to subsets attributes migration when a reference on superset relation exists, thanks to Valery Tschaen
- fixed class association position and dotted line
- fixed exception on incomplete or wrong associations links (when links count < 2)


### 2021-03-05 - v0.3.0

- added support for UML class and domain diagrams
- added Moodle filter plugin, thanks to Erwan Gallenne


### 2021-02-08 - v0.2.9

- fixed auto-increment type on subsets (SQL)
- improved sharing (URL with MFD selection, or embeding single view in iframe)


### 2021-02-03 - v0.2.8

- fixed (regression) error in weak entity handling
- fixed (copy/paste) error in foreign keys reference display (MR-EN)
- fixed (regression) missing newline in source code preventing processing of last line
- fixed (regression) redondant primary key when using "COUNTER" in SQL scripts
- fixed diagonal arrow visibility
- simplified web interface (using Multi-Function Display panes)
- added database diagram


### 2021-01-27 - v0.2.7

- fixed auto-increment in SQLite
- fixed broken reference when target relation is removed
- added a rectangle arround aggregations
- added arrows
- added table representation for relations


### 2020-09-29 - v0.2.6

- added support for MariaDB / MySQL
- added script generation support for PostgreSQL
- fixed '_' for first field (disable id)
- removed '-ss' (subset) option
- child entities changes:
	- fixed relational model generation with non null subsets intersection
	- added new & compatible syntax for sub entities (now supported by Mocodo)
	- children entities can now have their proper id
	- relational structure (parent + children, children only, parent only)
	can now be specified per set / subsets.
	- (old syntax is still supported for compatibility, but support will be
	removed in the future)


### 2020-07-07 - v0.2.5

- added examples (see doc/examples folder)
- added online example - thanks to Valentin Brosseau
- fixed bad column count when reading mocodo files
- fixed id strings containing spaces handling in MCDToMLD transformation


### 2020-06-16 - v0.2.4

- updated web application design & theme
- added web site generator, screenshot & icon

### 2020-06-05 - v0.2.3

- updated web application design & theme (WIP - by Sandy Grassineau)
- updated Checkstyle and upgraded to Haxe 4.1


### 2020-05-12 - v0.2.2

- fixed cardinalities position and diagonal bended lines
- fixed touch to move regression 


### 2020-05-10 - v0.2.1

- added swipe animation + touch to move pages feature
- added swipe on mouse wheel when shift key is pressed
- added support for vertical display
- added CSS to print only MCD and MLD
- simplified SVG code (using embeded stylesheet)
- added fullscreen MCD display
- added wrapper script for Java
- reset URL search string on input to prevent loss of data


### 2020-05-08 - v0.2.0

- added support for reverse engineering from an SQlite database
- added programmed unit tests and fixed some errors
- first try for auto-positionning
- added a proof of concept web application
- modified Mocodo source parser to allow live diagram generation


### 2020-02-11 - v0.1.1

- Mocodo-UX-FIX: now support lines with different columns count
- Mocodo-FIX: Subsets lines are no more taken into account for layout construction
- Mocodo-FIX: Children entities without additionnal fields
- ToMLD-FIX: 1-1 associations didn't had foreign keys
- ToMLD-FIX: subsets foreign keys weren't handled on 1 or 2 option ; parent relation is removed if possible (no other relation than children pointing to it) with option 1
